#!/bin/sh
#
# CopyLeft moon.cat
# Esta obra está bajo una licencia de Creative Commons
# http://creativecommons.org/licenses/by/3.0/deed.es
#
# Author: Rei Izumi - moon.cat - 2018
#
# Arguments (all required):
# 0 - IP/Name
# 1 - Port
# 2 - tcp/udp
#
# Return codes
# 0	- Port is open
# 1	- Invalid arguments
# 2	- Port is closed
#

errorCode=0

if [ ! -z "$1" ] && [ ! -z "$2" ] && [ ! -z "$3" ] ; then
	cmd="/dev/${3}/${1}/${2}"
	timeout 1 bash -c "echo > $cmd" > /dev/null 2> /dev/null
	code=$?
	if [ $code -eq 0 ] ; then
		echo "Port $1:$3/$2 is open"
		errorCode=0
	else
		echo "Port $1:$3/$2 is closed"
		errorCode=2
	fi
else
	echo "Usage: $0 <server> <port> <tcp/udp>"
	errorCode=1
fi

exit $errorCode
